// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage

	if (timer != null) {
		clearInterval(timer);
		timer = null;
	}
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide

	if (timer == null) {
		showTimetable();
		timer = setInterval("showTimetable();", 1000);
	}
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
	
	// 再取得のために取得時間消去
	receiveTime = null;	
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

// timer
var timer;

// 取得時間
var receiveTime = null;

// 取得可否フラグ
var boolAccess = false;

// おーすげーAJAXみたいだー
var httpObj = new XMLHttpRequest();

// 路線情報
var arrayLine = null;

// 方面情報
var arrayDirection = null;

// 本郷台 正常
//var urlBase = "http://www8.ekitan.com/norikae/Time2Servlet?AN=0&ST=&SF=%96%7B%8B%BD%91%E4&SFList=%89w%88%EA%97%97&x=60&y=45";

// エラー
//var urlBase = "http://www8.ekitan.com/norikae/Time2Servlet?AN=0&ST=&SF=本郷台&SFList=%89w%88%EA%97%97&x=60&y=45";

// 大船 正常 (路線画面)
//var urlBase = "http://www8.ekitan.com/norikae/Time2Servlet?SF=%91%E5%91D&SF_select=%89w%88%EA%97%97&SFDF=&SFCODE=&Submit.x=71&Submit.y=23&Submit=%91%97%90M&AN=0";

// URL情報 2007/11/05
var urlBaseFront = "http://www8.ekitan.com/norikae/Time2Servlet?AN=0&ST=&SF=";
var urlBaseTail = "&SFList=%89w%88%EA%97%97&x=60&y=45";

// URLの構成
// A_B-C_D_E
// A:鉄道会社(違うみたい/0固定か?)
// B:路線
// C:駅(路線毎)
// D:方向
// E:曜日・休日
//
// 時刻表表示ページにはhiddenで埋め込みあり
// name="SF":路線-駅
// name="DW":曜日
// name="D" :方向
// name="AN":0固定?

// 方向
var DIRECT_UP = "_1";
var DIRECT_DOWN = "_2";

// 曜日
var WEEK_DAY = "_0";
var WEEK_SAT = "_1";
var WEEK_HOLIDAY = "_2";

//
var URL_PATH = "http://www8.ekitan.com/norikae/Time/";

//
// 駅名検索ボタンイベント
//
function onClickSearch(event) {

	var stationName = document.getElementById("searchName").value;

	if (stationName == "") {
		document.getElementById("lblSearchStatus").innerText = "駅名を入力してください";
		return;
	}

	// URL作成
	var urlText = urlBaseFront + escape(utf2SJIS(stationName)) + urlBaseTail;

	boolAccess = false;

	document.getElementById("lblSearchStatus").innerText = "データ取得中";

	// Get Timetable Data
	getTimetable(urlText, callBackStationSearch);
}

//
// 路線検索ボタンイベント
//
function onClickDirection(event) {

	var idx = document.getElementById("popupLine").value;
	var textLine = document.getElementById("popupLine").text;

	if (textLine == "") {
		document.getElementById("lblSearchStatus").innerText = "路線を選択してください";
		return;
	}
	
	// URL作成
	var urlText = URL_PATH + arrayLine[idx][1] + ".html";

	boolAccess = false;

	document.getElementById("lblSearchStatus").innerText = "データ取得中";

	// Get Timetable Data
	getTimetable(urlText, callBackLineSearch);
}

//
// Get Timetable Data
// Success:Fire callbackFunction
//
function getTimetable(urlText, callbackFunction) {
	
	httpObj.open("GET", urlText, true);
	httpObj.onreadystatechange = function() {
		if (httpObj.readyState == 4) {
			callbackFunction();
		}
	}

	httpObj.send(null);	
}

//
// 駅名検索結果の解析処理
// 路線が一つの場合は、方向まで抜き出しを行う
// 複数の場合は路線の列挙を行う
//
function callBackStationSearch() {

	var i;

	arrayDirection = null;
	arrayLine = null;

	if (httpObj.status == 200) {

		var work = httpObj.document;
		var res = httpObj.responseText;

		// エラーチェック
		var textError = "";
		textError = searchDivTagDataByClass(res, "error_txt");

		if (textError != "") {
			document.getElementById("lblSearchStatus").innerText = textError;
			return;
		}

		// 路線チェック
		var textSingleLine = "";
		textSingleLine = searchDivTagDataByClass(res, "line");

		if (textSingleLine != "") {
			// 路線が一つ
			var arrayInfo = new Array(2);
			arrayInfo[0] = textSingleLine;
			arrayInfo[1] = pickoutLineStationURL(res);
			
			arrayLine = new Array();
			arrayLine.push(arrayInfo);

			// 方向抜きだし
			arrayDirection = pickoutDirection(res);
			boolAccess = true;

		} else {
			// 複数路線
			// 路線を列挙する
			arrayLine = enumLine(res);
		}
		
		// 路線情報更新
		updateLinePopup();
		
		// 方向情報更新
		updateDirectionPopup();
		
		document.getElementById("lblSearchStatus").innerText = "";

	} else {
		document.getElementById("lblSearchStatus").innerText = "HTTP Status:" + httpObj.status;
		alert("HTTP Request Fail");
	}
}

//
// 路線での時刻表表示結果の解析処理
// 方向の抜き出しを行う
//
function callBackLineSearch() {

	var i;

	arrayDirection = null;

	if (httpObj.status == 200) {

		var work = httpObj.document;
		var res = httpObj.responseText;

		document.getElementById("lblSearchStatus").innerText = "";

		// エラーチェック
		var textError = "";
		textError = searchDivTagDataByClass(res, "error_txt");

		if (textError != "") {
			document.getElementById("lblSearchStatus").innerText = textError;
			return;
		}

		// 路線チェック
		var textSingleLine = "";
		textSingleLine = searchDivTagDataByClass(res, "line");

		if (textSingleLine != "") {
			// 方向抜きだし
			arrayDirection = pickoutDirection(res);
			boolAccess = true;
		} else {
			// あり得ない
			document.getElementById("lblSearchStatus").innerText = "解析エラー";
			return;
		}
		
		// 方向情報更新
		updateDirectionPopup();
		
	} else {
		document.getElementById("lblSearchStatus").innerText = "HTTP Status:" + httpObj.status;
		alert("HTTP Request Fail");
	}
}

//
// 路線情報初期化
// グローバル変数で路線情報を初期化する
//
function updateLinePopup() {

	var i;
	var option;
		
	var popupLineObj = document.getElementById("popupLine");

	// 路線をクリア
	while (popupLineObj.hasChildNodes()) {
		popupLineObj.removeChild(popupLineObj.lastChild);
	}

	if (arrayLine == null) {
		return;
	}
		
	for(i = 0; i < arrayLine.length; i++) {
		option = document.createElement("option");
		option.setAttribute("value", i);
		option.innerText = getLocalizedString(arrayLine[i][0]);
		option.normalize();
		popupLineObj.appendChild(option);
	}
}

//
// 方向情報初期化
// グローバル変数で方向情報を初期化する
//
function updateDirectionPopup() {

	var i;
	var option;
		
	var popupDirectionObj = document.getElementById("popupDirection");

	// 方向をクリア
	while (popupDirectionObj.hasChildNodes()) {
		popupDirectionObj.removeChild(popupDirectionObj.lastChild);
	}

	if (arrayDirection == null) {
		return;
	}
		
	for(i = 0; i < arrayDirection.length; i++) {
		option = document.createElement("option");
		option.setAttribute("value", i);
		option.innerText = getLocalizedString(arrayDirection[i]);
		option.normalize();
		popupDirectionObj.appendChild(option);
	}
}

//
// 時刻表ページから会社_路線-駅までのURL引っこ抜き
//
function pickoutLineStationURL(textBase) {

	var textLine = splitTag(textBase, "name=\"SF\" value=\"", "\">");
	var textCo = splitTag(textBase, "name=\"AN\" value=\"", "\">");
	return(textCo + "_" + textLine)
}

//
// 時刻表ページから方向情報引っこ抜き
// 方向名称を配列で
//
function pickoutDirection(textBase) {

	var arrayDirectionData = new Array();

	var textPrimary = splitTag(textBase, "<span class=\"btnchs\">", "</span>");
	
	arrayDirectionData[0] = textPrimary;

	var textSecondary = splitTag(textBase, "<span class=\"btnnml\">", "</span>");
	textSecondary = splitTag(textSecondary, ".html\">", "</a>");

	if (textSecondary != "") {
		arrayDirectionData[1] = textSecondary;
	}
	
	return arrayDirectionData;
}

//
// divタグのidアトリビュート指定で抜き出し
//
function searchDivTagDataById(textBase, id) {
	return splitTag(textBase, "<div id=\"" + id +"\">\r\n", "</div>");
}

//
// divタグのClassアトリビュート指定で抜き出し
//
function searchDivTagDataByClass(textBase, id) {
	return splitTag(textBase, "<div class=\"" + id +"\">\r\n", "</div>");
}

//
// MainContents抜き出し
//
function searchMainContents(textBase) {
	return splitTag(textBase, "<!-- [ maincontents ] -->", "<!-- /[ maincontents ] -->");
}

//
// 路線名配列取得
// 戻り値は2次元配列で、路線名とURL
//
function enumLine(textBase) {

	var i;
	var arrayLineData = new Array();
	var arrayTextLine = textBase.split("\n");
	
	for (i = 0; i < arrayTextLine.length;i++) {
		var infoLine = getLineArray(arrayTextLine[i]);

		if (infoLine == null) {
			continue;
		}

		arrayLineData.push(infoLine);
	}

	if (arrayLineData.length == 0) {
		return null;
	}

	return arrayLineData;
}

//
// 路線名、路線駅コードを抜き出す
//
function getLineArray(textBase) {

	if (textBase.indexOf("class=\"name\"") == -1) {
		return null;
	}

	var arrayInfo = new Array(2);
	arrayInfo[0] = splitTag(textBase, "[", "]");
	arrayInfo[1] = splitTag(textBase, "/norikae/Time/", ".html");
	
	if (arrayInfo[0] == "" || arrayInfo[1] == "") {
		return null;
	}

	return(arrayInfo);
}

//
// 指定文字間の抜き出し
//
function splitTag(textBase, textStart, textEnd) {

	idxId = textBase.indexOf(textStart);
	if (idxId == -1) {
		return("");
	}
	
	idxEnd = textBase.indexOf(textEnd, idxId + 1);
	
	return(textBase.substring(idxId + textStart.length, idxEnd));
}

//
// 文字コード変換
//
function utf2SJIS(textSjis) {
	return widget.system("/bin/echo -n '"
							+ textSjis
							+ "' | /usr/bin/iconv -f UTF8-MAC -t shift-jis",
						null).outputString;
}

////////////////////////////////////////////////////////////////////////////
//
// 表側処理
//
////////////////////////////////////////////////////////////////////////////

// 簡易排他フラグ
var exShowProc = false;


// 時刻表情報を保持する
var arrayTimetable = null;

// ページタイトル
var pageTitle = null;


// 日替わり時間
var dateIncrementHour = 3;

//
// 表側表示メイン
//
function showTimetable() {

	// アクセス可能か?
	if (boolAccess == false) {
		return;
	}

	if (front.style.display != "block") {
		return;
	}

	// 現在時刻取得
	var dateNow = new Date();

	// 前回取得からの時間経過チェック
	// 今のところ1分毎に更新
	if (receiveTime != null
		&& receiveTime.getHours() == dateNow.getHours()
		&& receiveTime.getMinutes() == dateNow.getMinutes()) {
		return;
	}
	
//	receiveTime = dateNow;

	// 簡易排他処理
	// JSだからこんなもんか
	if (exShowProc == true) {
		return;
	}
	exShowProc = true;

	// 未取得か取得日が異なるか午前6時前であればデータ更新を行う
	if (receiveTime == null
		|| receiveTime.getDate() != dateNow.getDate()
		|| (receiveTime.getHours() != dateNow.getHours()
			&& dateNow.getHours() < 6)) {

		// URL取得
		var urlTimetable = createTimetableUrl(dateNow);
	
		document.getElementById("lblStatus").innerText = "情報更新中";

		// Get Timetable Data
		getTimetable(urlTimetable, callBackTimetable);

		return;

	} else {
		// 画面更新
		updateViewTimetable();
		exShowProc = false;
		receiveTime = dateNow;
	}
	
}

//
// 指定の駅、路線、方向の今日の時刻表のURL作成
//
function createTimetableUrl(dateNow) {

	var textDirection;
	var textWeek;

	var idxLine = document.getElementById("popupLine").value;
	var idxDirection = document.getElementById("popupDirection").value;
	
	if (idxDirection == 0) {
		textDirection = DIRECT_UP;
	} else {
		textDirection = DIRECT_DOWN;
	}
	
	// TODO:祝日対応はどうするか?
	var week = dateNow.getDay();
	
	if (week == 0) {
		// 日曜
		textWeek = WEEK_HOLIDAY;
	} else if (week ==6) {
		// 土曜
		textWeek = WEEK_SAT;
	} else {
		// 平日
		textWeek = WEEK_DAY;
	}
	
	var urlText = URL_PATH + arrayLine[idxLine][1] + textDirection + textWeek + ".html";

	return urlText;
}

//
// 路線での時刻表表示結果の解析処理
// 方向の抜き出しを行う
//
function callBackTimetable() {

	//
	// 正否関係なく、終了時のexShowProc=falseを忘れないように
	//

	var i;

	// データ取得時刻
	// とりあえずは正否関係なく更新する
	receiveTime = new Date();

	if (httpObj.status == 200) {

		var res = httpObj.responseText;

		// エラーチェック
		var textError = "";
		textError = searchDivTagDataByClass(res, "error_txt");

		if (textError != "") {
			document.getElementById("lblStatus").innerText = textError;
			exShowProc = false;
			return;
		}

		document.getElementById("lblStatus").innerText = "";

		// タイトル
		var textTitle = splitTag(res, "meta name=\"description\" content=\"", ">");
		pageTitle = splitTag(textTitle, "「", "」").split("　");
		
		document.getElementById("lblTitle").innerText = pageTitle[0];
		document.getElementById("lblTitle1").innerText = pageTitle[1] + " " + pageTitle[2];

		// 時刻表抜きだし
		var textTimetableUnit = splitTag(res, "<div class=\"timetable\">", "<div class=\"recital\">");

		// 時刻情報の設定
		arrayTimetable = createTimetabelArray(textTimetableUnit);

		// 表示
		updateViewTimetable();
	
	} else {
		document.getElementById("lblStatus").innerText = "HTTP Status:" + httpObj.status;
		alert("HTTP Request Fail");
	}
	
	exShowProc = false;
}

//
// 時刻表の内容を解析し時刻表情報配列を作成する
//
function createTimetabelArray(textBase) {

	var i;
	var j;
	var arrayLineData = new Array();
	
	var arrayTextLine = textBase.split("\n");

	// 汚い
	// 2重ループでインデックスいじりまくり
	// きれいにHTML解析できるDOM見たいので作り直そう

	// text解析
	lineReadMain:
	for (i = 0; i < arrayTextLine.length; i++) {
	
		var textLine = arrayTextLine[i];
	
		// 時間を探す
		if (textLine.indexOf("<td class=\"hour") == -1) {
			continue lineReadMain;
		}
	
		// 時間読み込み
		var hourRead = parseInt(splitTag(textLine, ">", "<"));
	
		// AM3より前は24足す
		// 正月の24時間運転の場合はどうなるんだろ
		if (hourRead < dateIncrementHour) {
			hourRead = hourRead + 24;
		}
	
		minuteRead:
		for (j = 1; j < arrayTextLine.length - i; j++) {
			
			textLine = arrayTextLine[i + j];
			
			// テーブルの区切りで時間データ終わり
			if (textLine.indexOf("<tr") != -1) {
				break minuteRead;
			}
			
			// 分データを探す
			if (textLine.indexOf("<div class=\"minute\">") == -1) {
				continue minuteRead;
			}
			
			j++;
			var textLineInfo = arrayTextLine[i + (j++)];
			var textLineMinute = arrayTextLine[i + (j++)];

			var arrayMinInfo = new Array();
			arrayMinInfo.push(hourRead);
			arrayMinInfo.push(chooseMinute(textLineMinute));
			arrayMinInfo.push(chooseInfo(textLineInfo));
			
			// 分データを時間データへ入れる
			arrayLineData.push(arrayMinInfo);
		}
		
		// 分データの行数をインクリメントする
		// 数行取りこぼし、複数取り込みの可能性ありだけど、実害無いから気にしない
		i = i + j;
	
	}

	return arrayLineData;
}

//
// 情報の抜き出し・表示用に編集
//
function chooseInfo(textInfo) {

	var infoStation = splitTag(textInfo, "<span>", "</span>");
	var infoType = splitTag(textInfo, "<span class=\"variety\">", "</span>");

	if (infoStation != "") {
		return infoStation + "/" + infoType;
	} else {
		return infoType;
	}
}

//
// 情報の抜き出し・表示用に編集
//
function chooseMinute(textInfo) {

	var textMin = splitTag(textInfo, "<span class=\"normal\"><", "</span>");

	if (textMin == "") {
		textMin = splitTag(textInfo, "<font color", "</span>");
	}

	var min = splitTag(textMin, ">", "<");

	return parseInt(min);
}

//
// 時刻表更新
//
function updateViewTimetable() {

	var i;

	// 更新する時間のオフセット値
	var increment = parseInt(document.getElementById("textIncrementTime").value);

	if (increment == NaN) {
		increment = 0;
	}

	var baseTime = new Date();
	baseTime.setTime(baseTime.getTime() + (increment * 60 * 1000));

	// 検索する時刻
	var hour = baseTime.getHours();
	var min = baseTime.getMinutes();

	// 日替わり補正
	if (hour < dateIncrementHour) {
		hour += 24;
	}

	// 指定時刻の時刻表検索
	for (i = 0; i < arrayTimetable.length; i++) {

		var arrayMinInfo = arrayTimetable[i];

		// 直近の時刻表を探す
		if (arrayMinInfo[0] > hour
			|| (arrayMinInfo[0] == hour
				&& arrayMinInfo[1] >= min)) {
			break;
		}
	}

	var idx = i;

	// 終電すぎは始発にする
	if (idx > arrayTimetable.length) {
		idx = 0;
	}

	for (i = 0; i < 4; i++) {
		var lookup = idx + (i - 1);
		
		// 始発前か終電後
		if (lookup < 0) {
			lookup = arrayTimetable.length + lookup;
		} else if (lookup >= arrayTimetable.length) {
			lookup = lookup - arrayTimetable.length;
		}
		
		var arrayViewMinInfo = arrayTimetable[lookup];

		var textTimeName = "textTime" + i;
		var textInfoName = "textInfo" + i;
		
		// 表示内容更新
		var textTime = "";
		
		if (arrayViewMinInfo[0] < 10) {
			textTime = "0";
		}
		textTime += arrayViewMinInfo[0] + ":";
		
		if (arrayViewMinInfo[1] < 10) {
			textTime += "0";
		}
		textTime += arrayViewMinInfo[1];
		
		document.getElementById(textTimeName).innerText = textTime;
		document.getElementById(textInfoName).innerText = arrayViewMinInfo[2];
		
	}
}
